#pragma once
#include "NScrollBar.h"
#include "ImageProxy.h"

class CScrollBarUI_Img : public IScrollBarUI
{
public:
	typedef struct tagSCROLLBARUI_INFO
	{
		IImage* pImgBtn_LeftTop;
		IImage* pImgBtn_RightBottom;
		IImage* pImgThumb_1;
		IImage* pImgThumb_2;
		IImage* pImgThumb_3;
		IImage* pImgThumb_4;
		IImage* pImgThumb_5;
		IImage* pImgBgNormal;
		IImage* pImgBgSelected;
		BOOL bHorz;
	} SCROLLBARUI_INFO;
	typedef SCROLLBARUI_INFO* PSCROLLBARUI_INFO;

	CScrollBarUI_Img(PSCROLLBARUI_INFO pInfo);
	virtual ~CScrollBarUI_Img();

	DECLARE_RTTI

	int GetBtnWidth();

	//override
	//IScrollBarUI
	void		DrawBackground(HDC hDC, CNScrollBar* pNSB, PRECT pRcShaftSelected);
	void		SetLUPanelUI(IPanelUI* pPanelUI) {}
	IPanelUI*	GetLUPanelUI();
	void		SetRDPanelUI(IPanelUI* pPanelUI) {}
	IPanelUI*	GetRDPanelUI();
	void		SetThumbPanelUI(IPanelUI* pPanelUI) {}
	IPanelUI*	GetThumbPanelUI();
	void		SetHandlePanelUI(IPanelUI* pPanelUI) {}
	IPanelUI*	GetHandlePanelUI(); 
protected:
private:
	SCROLLBARUI_INFO m_Info;

	class CPanelUI_ScrollBarUI : public IPanelUI
	{
	public:
		CPanelUI_ScrollBarUI(IImage* pImg);
		virtual ~CPanelUI_ScrollBarUI();

		DECLARE_RTTI;

		//override
		//IPanelUI
		void	DrawPanel(HDC hDC, CNPanel* pPanel);
	protected:
	private:
		IImage* m_pImg;
	};

	class CPanelUI_ScrollBarUI_Thumb : public IPanelUI
	{
	public:
		typedef struct tagTHUMBINFO
		{
			IImage* pImg1;
			IImage* pImg2;
			IImage* pImg3;
			IImage* pImg4;
			IImage* pImg5;
			BOOL bHorz;
		} THUMBINFO;
		typedef THUMBINFO* PTHUMBINFO;

		CPanelUI_ScrollBarUI_Thumb(PTHUMBINFO pInfo);
		virtual ~CPanelUI_ScrollBarUI_Thumb();

		DECLARE_RTTI;

		//override
		//IPanelUI
		void	DrawPanel(HDC hDC, CNPanel* pPanel);
	protected:
	private:
		THUMBINFO m_Info;
	};

	CAutoPtr<CPanelUI_ScrollBarUI> m_pPanelUI_LeftTop;
	CAutoPtr<CPanelUI_ScrollBarUI> m_pPanelUI_RightBottom;
	CAutoPtr<CPanelUI_ScrollBarUI_Thumb> m_pPanelUI_Thumb;
};